"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRexStore = void 0;

var _react = _interopRequireDefault(require("react"));

var _useContextSelector = require("use-context-selector");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createRexStore = useRexState => {
  const RexContext = (0, _useContextSelector.createContext)(null);
  const {
    Provider
  } = RexContext;

  function useStore(selector) {
    const store = (0, _useContextSelector.useContextSelector)(RexContext, selector || (ctx => ctx));

    if (!store) {
      throw new Error('Component must be wrapped with a suitable <RexProvider>');
    }

    return store;
  }

  const RexProvider = ({
    children,
    value
  }) => {
    const state = useRexState(value);
    return /*#__PURE__*/_react.default.createElement(Provider, {
      value: state
    }, children);
  };

  return {
    RexProvider,
    useStore
  };
};

exports.createRexStore = createRexStore;
//# sourceMappingURL=index.js.map