import React from 'react';
import { createContext, useContextSelector } from 'use-context-selector';
export const createRexStore = useRexState => {
  const RexContext = createContext(null);
  const {
    Provider
  } = RexContext;

  function useStore(selector) {
    const store = useContextSelector(RexContext, selector || (ctx => ctx));

    if (!store) {
      throw new Error('Component must be wrapped with a suitable <RexProvider>');
    }

    return store;
  }

  const RexProvider = ({
    children,
    value
  }) => {
    const state = useRexState(value);
    return /*#__PURE__*/React.createElement(Provider, {
      value: state
    }, children);
  };

  return {
    RexProvider,
    useStore
  };
};
//# sourceMappingURL=index.js.map